package com.mappls.sdk.direction.ui.react;

import android.app.Activity
import android.os.Bundle
import androidx.appcompat.app.AppCompatActivity
import com.mappls.sdk.direction.ui.DirectionCallback
import com.mappls.sdk.direction.ui.DirectionFragment
import com.mappls.sdk.direction.ui.model.DirectionOptions
import com.mappls.sdk.direction.ui.model.DirectionPoint
import com.mappls.sdk.services.api.directions.models.DirectionsResponse

class DirectionActivity : AppCompatActivity() {
  lateinit var directionFragment: DirectionFragment

   lateinit var directionOptions: DirectionOptions
  override fun onCreate(savedInstanceState: Bundle?) {
    super.onCreate(savedInstanceState)
    setContentView(R.layout.activity_direction)


//    if(intent != null) {
//      directionOptions = intent.getParcelableExtra("builder") ?: DirectionOptions.builder().build()
//      intent.extras?.clear()
//    }

    MapplsDirectionSetting.getInstance().directionOptions?.let {
      directionOptions = it.build()
    }

    directionFragment = DirectionFragment.newInstance(directionOptions)

    if (MapplsDirectionSetting.getInstance().categoryCodes!=null){
      directionFragment.setCategoryCodes(MapplsDirectionSetting.getInstance().categoryCodes)
    }
    supportFragmentManager.beginTransaction().replace(R.id.fragment_container, directionFragment, DirectionFragment::class.java.simpleName)
      .commit()


    directionFragment.setDirectionCallback(object : DirectionCallback {
      override fun onStartNavigation(origin: DirectionPoint?, destination: DirectionPoint?, waypoints: MutableList<DirectionPoint>?, directionsResponse: DirectionsResponse?, selectedIndex: Int) {
        val waypointList= ArrayList<DirectionPoint>()

        if (waypoints != null) {
          for (point in waypoints){
              waypointList.add(point)
          }
        }

        MapplsDirectionSetting.getInstance().destination = destination
        MapplsDirectionSetting.getInstance().origin = origin
        MapplsDirectionSetting.getInstance().wayPoints = waypointList
        MapplsDirectionSetting.getInstance().directionsResponse = directionsResponse
        MapplsDirectionSetting.getInstance().selectedIndex = selectedIndex
        //val sharedPreferences=getSharedPreferences("response", Context.MODE_PRIVATE).edit()
       // sharedPreferences.putString("directionsResponse",directionsResponse?.toJson()).apply()

        setResult(Activity.RESULT_OK)
        finish()
      }

      override fun onCancel() {
        setResult(Activity.RESULT_CANCELED)
        finish()
      }

    })
  }



}




