package com.mappls.sdk.direction.ui.react

import com.mappls.sdk.direction.ui.model.DirectionOptions
import com.mappls.sdk.direction.ui.model.DirectionPoint
import com.mappls.sdk.nearby.plugin.CategoryCode
import com.mappls.sdk.services.api.directions.models.DirectionsResponse

class MapplsDirectionSetting private constructor(){

  var directionOptions:  DirectionOptions.Builder?= null
  var categoryCodes:List<CategoryCode>? = null
  var directionsResponse: DirectionsResponse? = null
  var origin: DirectionPoint? = null
  var destination: DirectionPoint? = null
  var wayPoints: List<DirectionPoint>? = null
  var selectedIndex: Int? = null

  companion object {
    private val OUR_INSTANCE: MapplsDirectionSetting by lazy { MapplsDirectionSetting() }
    fun getInstance(): MapplsDirectionSetting {
      return OUR_INSTANCE
    }
  }


  fun clear() {
    directionOptions = null
    categoryCodes = null
    directionsResponse = null
    origin = null
    destination = null
    wayPoints = null
    selectedIndex = null
  }

}
